
const OPER01010_GRID_ID = '#ITP_OPER01010_jqGrid';
const OPER01010_GRID_LIST = '#ITP_OPER01010_jqGrid_list';
const OPER01010_GRID_PAGER = '#ITP_OPER01010_jqGridPager';
const OPER01010_GRID_EMPTY = '#ITP_OPER01010_jqGridEmpty';

const OPER01010_VIEW_GRID_ID = '#ITP_OPER01010_VIEW_jqGrid';
const OPER01010_VIEW_GRID_LIST = '#ITP_OPER01010_VIEW_jqGrid_list';
const OPER01010_VIEW_GRID_PAGER = '#ITP_OPER01010_VIEW_jqGridPager';
const OPER01010_VIEW_GRID_EMPTY = '#ITP_OPER01010_VIEW_jqGridEmpty';

const OPER01010_DETAIL_GRID_ID = '#ITP_OPER01010_DETAIL_jqGrid';
const OPER01010_DETAIL_GRID_LIST = '#ITP_OPER01010_DETAIL_jqGrid_list';
const OPER01010_DETAIL_GRID_PAGER = '#ITP_OPER01010_DETAIL_jqGridPager';
const OPER01010_DETAIL_GRID_EMPTY = '#ITP_OPER01010_DETAIL_jqGridEmpty';

let ITP_FORM_OPER01010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_OPER01010_DETAIL_IS_WRITING = false;

let USER_DETAIL_GRID_LIST = '/api/user/detail-grid-list';
let USER_USERAUTH_GRID_LIST = '/api/user/userauth-grid-list';
let USER_INFO_USER = '/api/user/info-user';
let USER_SAVE_USER = '/api/user/save-user';
let USER_CHECK_DUPLICATE = '/api/user/check-duplicate';
let USER_INTI_USERPW = '/api/user/inti-userpw';

require(['config'], function() {
	require([
		'jquery'
	], function($) {
		// 버튼 권한설정
		fn_proc_btn_auth('OPER01010');
		// 공통코드 표시
		fn_make_select(CODE_LIST, 'USER_STAT_CD', 'ITP_FORM_OPER01010_SEARCH_USER_STAT_CD');
		fn_make_select(CODE_LIST, 'USER_STAT_CD', 'ITP_FORM_OPER01010_DETAIL_USER_STAT_CD', true, '선택');
		
		// 조회일자 지정
		var now = new Date();
		$('#ITP_TAB_OPER01010 .input-group.date').datepicker(ITP_DATE_LANGUAGE);
		// $('#ITP_FORM_OPER01010_SEARCH_FROM_DT').datepicker('setDate', new Date(now.setMonth(now.getMonth() - 1)));
		// $('#ITP_FORM_OPER01010_SEARCH_TO_DT').datepicker('setDate', new Date());

		// 가맹점 조회
		itp_fn_OPER01010_brand_search.init();
				
		// 그리드				
		itp_fn_jqgrid_resize(OPER01010_GRID_ID, OPER01010_GRID_LIST, 'lg');
		itp_fn_OPER01010_grid.init();
    	itp_fn_fire_window_resize();

		// 조회    	
    	itp_fn_OPER01010_search();
    	
		// 조회 버튼 클릭
		$('#ITP_BTN_OPER01010_SRH').on('click', function() {
			itp_OPER01010_search = true;
			let param = $('#ITP_FORM_OPER01010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(OPER01010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		});
		
		// 수정 버튼
		$('#ITP_BTN_OPER01010_MODIFY').on('click', function() {
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPER01010_DETAIL');			
			const userIdVal = $('#ITP_FORM_OPER01010_VIEW_USER_ID').val();
			const key = {userId: userIdVal, viewCd: 'R'};
			var param = $.param(key);
			itp_fn_OPER01010_detail(param);	
		});
		
		// 신규등록 버튼
		$('#ITP_BTN_OPER01010_NEWREG').on('click', function() {
			itp_fn_OPER01010_switch_screen('ADD');			
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPER01010_DETAIL');				
			// 권한정보 리스트 조회
			itp_fn_OPER01010_detail_grid.unload();
			itp_fn_OPER01010_detail_grid.callBack();
		});
		
		// 취소/목록 버튼
		$('#ITP_BTN_OPER01010_CANCELLIST').on('click', function() {
			itp_fn_OPER01010_search();
    	});
		
		// 삭제 버튼
		$('#ITP_BTN_OPER01010_DELETE').on('click', function() {
			
		});
		
		// 저장 버튼
		$('#ITP_BTN_OPER01010_SAVE').on('click', function() {			
			const formId = '#ITP_FORM_OPER01010_DETAIL';
			itp_fn_form_clear_validate(null, formId);			
			var vali_userId = itp_fn_form_validate(formId, formId + '_USER_ID', ['empty'], undefined);
			var vali_userStatCd = itp_fn_form_validate(formId, formId + '_USER_STAT_CD', ['empty'], undefined);
			var vali_userNm = itp_fn_form_validate(formId, formId + '_USER_NM', ['empty'], undefined);
			var vali_telNo = itp_fn_form_validate(formId, formId + '_TEL_NO', ['empty'], undefined);
			var vali_email = itp_fn_form_validate(formId, formId + '_EMAIL', ['empty'], undefined);
			var vali_userPw = true;
			var vali_userPwConfirm = true;
			if($('#ITP_FORM_OPER01010_DETAIL_VIEW_CD').val() == 'C') { // 신규
				vali_userPw = itp_fn_form_validate(formId, formId + '_USER_PW', ['empty'], undefined);
				vali_userPwConfirm = itp_fn_form_validate(formId, formId + '_USER_PW_CONFIRM', ['empty'], undefined);	
			}
			if (vali_userId && vali_userStatCd && vali_userNm && vali_userPw && vali_userPwConfirm && vali_telNo && vali_email) {
				if (ITP_FORM_OPER01010_DETAIL_IS_DUPLICATE) {
					itp_fn_modal_duplicate(ITP_MSG_LOCALE.label.userId, formId + '_USER_ID');
				} else {
					let gridInsertData = [];
					let gridUpdateData = [];
					let gridDeleteData = [];
					const rowData = $(OPER01010_DETAIL_GRID_ID).getRowData();
					const keyValue = $(formId + '_USER_ID').val();
					$.each(rowData, function(key, value) {
						if (value.viewCd != 'R') {
							value.userId = keyValue;
							if (value.viewCd == 'C') {
								gridInsertData.push(value);
							} else if (value.viewCd == 'U') {
								gridUpdateData.push(value);
							} else if (value.viewCd == 'D') {
								gridDeleteData.push(value);
							}
						}
					});
					let param = $(formId).serializeObject();
					param.gridInsertData = gridInsertData;
					param.gridUpdateData = gridUpdateData;
					param.gridDeleteData = gridDeleteData;
					//console.log(JSON.stringify(param)); 						
					var searhFn = function() {
						ITP_FORM_OPER01010_DETAIL_IS_WRITING = false;
						itp_fn_OPER01010_search();
					};
					fn_ajax_call(USER_SAVE_USER, JSON.stringify(param), searhFn, 'POST');	
				}
			}
		});		
		
		// 중복체크
		$('#ITP_FORM_OPER01010_DETAIL_DUP').on('click', function() {
			const formId = '#ITP_FORM_OPER01010_DETAIL';
			itp_fn_form_clear_validate(null, formId + '_DETAIL');
			var vali_userId = itp_fn_form_validate(formId + '_DETAIL', formId + '_USER_ID', ['empty'], undefined);
			if (vali_userId) {
				var dupFn = function(result) {
					if (result.code == 'N') {
						ITP_FORM_OPER01010_DETAIL_IS_DUPLICATE = false;
					} else {
						ITP_FORM_OPER01010_DETAIL_IS_DUPLICATE = true;
					}
				};
				const key = {'userId':  $(formId + '_USER_ID').val()};
				const param = $.param(key);
				fn_ajax_call(USER_CHECK_DUPLICATE, param, dupFn, 'GET');
			}
		});
		
		// 상세:비밀번호 초기화
		$('#ITP_BTN_OPER01010_RESET_PW').on('click', function() {
			var resetPwFn = {
				callBack: function(args) {
					const key = {'userId':  $('#ITP_FORM_OPER01010_DETAIL_USER_ID').val()};
					const param = $.param(key);
					fn_ajax_call(USER_INTI_USERPW, param, undefined, 'GET');					
				}
			};
			itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.askResetUserPw, resetPwFn, null);		
		});
		// 상세:추가버튼
		$('#ITP_BTN_OPER01010_DETAIL_ADDROW').on('click', function() {
			// 팝업
			var popFn = function(rowDataPop) {
				// 기존등록 데이터 
				var exists = '';				
				const rowData = $(OPER01010_DETAIL_GRID_ID).getRowData();
				$.each(rowData, function(key, value) {
					exists = exists + value.authNo + ';';
				});
				
				$.each(rowDataPop, function(key, value) {
					if(exists.indexOf(value.authNo) < 0) {
						// 행추가
						$(OPER01010_DETAIL_GRID_ID).jqGrid('addRow', {position: 'last'});
						var rids = $(OPER01010_DETAIL_GRID_ID).jqGrid('getDataIDs');
						var last_row_id = rids[rids.length - 1];
						$(OPER01010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'viewCd', 'C');
						$(OPER01010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'authNo', value.authNo);
						$(OPER01010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'authNm', value.authNm);	
					}
				});
				$(OPER01010_DETAIL_GRID_EMPTY).hide();
			};
			fn_call_popup('comm', 'AUTH_SCH_POPUP', '#ITP_ASIDE', popFn, null, 'S');
		});
		// 상세:삭제버튼
		$('#ITP_BTN_OPER01010_DETAIL_DELROW').on('click', function() {
			itp_fn_grid_del_row(OPER01010_DETAIL_GRID_ID);
		});
		
		$('body').on('click', function(e) {
			var gridId = OPER01010_DETAIL_GRID_ID.replace('#', '');
			var rids = $(OPER01010_DETAIL_GRID_ID).jqGrid('getDataIDs');
			var last_row_id = rids[rids.length - 1];			
			itp_fn_grid_reset_selection(e, last_row_id, gridId, 'OPER01010_DETAIL');
		});
	});
});

var itp_fn_OPER01010_switch_screen = function(mode) {
	if(mode == 'LIST') { // 목록
		$('#ITP_BTN_OPER01010_MODIFY').hide();
		$('#ITP_BTN_OPER01010_CANCELLIST').hide();
		$('#ITP_BTN_OPER01010_DELETE').hide();
		$('#ITP_BTN_OPER01010_SAVE').hide();
		fn_show_btn_auth('#ITP_BTN_OPER01010_SRH');
		fn_show_btn_auth('#ITP_BTN_OPER01010_NEWREG');
		
		$('#ITP_AJAX_OPER01010_LIST_CONTAINER').show();
		$('#ITP_AJAX_OPER01010_DETAIL_CONTAINER').hide();		
		$('#ITP_AJAX_OPER01010_VIEW_CONTAINER').hide();
	} else if(mode == 'ADD') { // 등록
		ITP_FORM_OPER01010_DETAIL_IS_DUPLICATE = true;
	
		$('#ITP_BTN_OPER01010_SRH').hide();
		$('#ITP_BTN_OPER01010_MODIFY').hide();
		$('#ITP_BTN_OPER01010_NEWREG').hide();
		$('#ITP_BTN_OPER01010_DELETE').hide();
		$('#ITP_BTN_OPER01010_RESET_PW').hide();
		fn_show_btn_auth('#ITP_BTN_OPER01010_CANCELLIST');
		fn_show_btn_auth('#ITP_BTN_OPER01010_SAVE');
		
		$('#ITP_AJAX_OPER01010_LIST_CONTAINER').hide();
		$('#ITP_AJAX_OPER01010_DETAIL_CONTAINER').show();
		$('#ITP_AJAX_OPER01010_VIEW_CONTAINER').hide();		
		$('#ITP_FORM_OPER01010_DETAIL_USER_ID').removeAttr('readonly');
		$('#ITP_FORM_OPER01010_DETAIL_DUP').removeAttr('disabled');
		
		$('#ITP_FORM_OPER01010_DETAIL_VIEW_CD').val('C');
		$('#ITP_FORM_OPER01010_DETAIL_USER_NM').val('');
		$('#ITP_FORM_OPER01010_DETAIL_USER_STAT_CD').val('');
		$('#ITP_FORM_OPER01010_DETAIL_USER_ID').val('');
		$('#ITP_FORM_OPER01010_DETAIL_USER_PW').val('');
		$('#ITP_FORM_OPER01010_DETAIL_TEL_NO').val('');
		$('#ITP_FORM_OPER01010_DETAIL_USER_PW_CONFIRM').val('');
		$('#ITP_FORM_OPER01010_DETAIL_EMAIL').val('');
	} else if(mode == 'MODIFY') { // 수정
		$('#ITP_BTN_OPER01010_SRH').hide();
		$('#ITP_BTN_OPER01010_MODIFY').hide();
		$('#ITP_BTN_OPER01010_NEWREG').hide();		
		$('#ITP_BTN_OPER01010_DELETE').hide();
		fn_show_btn_auth('#ITP_BTN_OPER01010_CANCELLIST');
		fn_show_btn_auth('#ITP_BTN_OPER01010_SAVE');
		fn_show_btn_auth('#ITP_BTN_OPER01010_RESET_PW');	
		
		$('#ITP_AJAX_OPER01010_LIST_CONTAINER').hide();
		$('#ITP_AJAX_OPER01010_DETAIL_CONTAINER').show();
		$('#ITP_AJAX_OPER01010_VIEW_CONTAINER').hide();
		$('#ITP_FORM_OPER01010_DETAIL_USER_ID').attr('readonly', true);
		$('#ITP_FORM_OPER01010_DETAIL_DUP').attr('disabled', true);
	} else if(mode == 'VIEW') { // 보기
		$('#ITP_BTN_OPER01010_SRH').hide();
		$('#ITP_BTN_OPER01010_NEWREG').hide();		
		$('#ITP_BTN_OPER01010_DELETE').hide();
		$('#ITP_BTN_OPER01010_SAVE').hide();
		fn_show_btn_auth('#ITP_BTN_OPER01010_MODIFY');
		fn_show_btn_auth('#ITP_BTN_OPER01010_CANCELLIST');
		
		$('#ITP_AJAX_OPER01010_LIST_CONTAINER').hide();
		$('#ITP_AJAX_OPER01010_DETAIL_CONTAINER').hide();
		$('#ITP_AJAX_OPER01010_VIEW_CONTAINER').show();
	}	
};

var itp_fn_OPER01010_grid = {
	init: function() {
		// 데이터 없을때
		itp_fn_OPER01010_empty.push();
		$(OPER01010_GRID_EMPTY).on('click', function() {
			itp_fn_OPER01010_empty.back();
			itp_OPER01010_param.gridSize = $.jgrid.defaults.rowNum;
			$(OPER01010_GRID_ID).setGridParam({'postData': JSON.stringify(itp_OPER01010_param)}).trigger('reloadGrid');
		});	
	},
	colModel: [
		{
			index: 'AFFL_SHOP_NM', name: 'afflShopNm',
			label: ITP_MSG_LOCALE.label.afflShopNm, //가맹점
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'BRAND_NM', name: 'brandNm',
			label: ITP_MSG_LOCALE.label.brandNm, //브랜드
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'USER_ID', name: 'userId',
			label: ITP_MSG_LOCALE.label.userId, //사용자ID
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'USER_NM', name: 'userNm',
			label: ITP_MSG_LOCALE.label.userName, //닉네임
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'EMAIL', name: 'email',
			label: ITP_MSG_LOCALE.label.idEmail, //아이디(이메일)
			width: '15', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'TEL_NO', name: 'telNo',
			label: ITP_MSG_LOCALE.label.telNo, //휴대폰 번호
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'USER_STAT_NM', name: 'userStatNm',
			label: ITP_MSG_LOCALE.label.status, //상태
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'USER_STAT_DT', name: 'userStatDt',
			label: ITP_MSG_LOCALE.label.statusDt, //상태일시
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ADD_DT', name: 'addDt',
			label: ITP_MSG_LOCALE.label.regDt, //등록일
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'LAST_LOGIN_DT', name: 'lastLoginDt',
			label: ITP_MSG_LOCALE.label.lastLogin, //마지막 로그인
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		}
	],
	callBack: function() {
		let param = $('#ITP_FORM_OPER01010_SEARCH').serializeObject();
		param.gridSize = $.jgrid.defaults.rowNum;	
		$(OPER01010_GRID_ID).jqGrid({
			colModel: this.colModel,
			loadBeforeSend: function(jqXHR) {
			    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
			},
			postData: JSON.stringify(param),
			url: DOMAIN + USER_DETAIL_GRID_LIST,
			pager: OPER01010_GRID_PAGER,
			multiselect: false,
			rownumbers: true, 
			onCellSelect: function(rowId, cellIdx, cellValue) {
				var cm = $(this).jqGrid('getGridParam', 'colModel');
				var colNm = cm[cellIdx].name;
				if (colNm == 'userNm') {
					const userIdVal = $(this).jqGrid('getCell', rowId, 'userId');
					const key = {userId: userIdVal, viewCd: 'R'};
					var param = $.param(key);
					itp_fn_OPER01010_view(param);
				}
		   	},
			loadComplete: function(data) {
				//console.log(JSON.stringify(data));
				itp_fn_grid_load_complete(data, OPER01010_GRID_ID, true, 'number', 'OPER01010', itp_OPER01010_search, itp_fn_OPER01010_empty, true, data.gridRecords, true);
				var ids = $(OPER01010_GRID_ID).getDataIDs();
				$.each(ids, function(idx, rowId) {
					$(OPER01010_GRID_ID).jqGrid('setCell', rowId, 'userNm', '', ITP_GRID_COL_STYLE.link);
				});	
		    },
		    loadError: function(jqXHR, textStatus, errorThrown) {
		    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
		    },
		    onPaging: function(action) {
		    	itp_fn_grid_paging(OPER01010_GRID_ID, action, param);
		    }
		}).navGrid(OPER01010_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
	},
	clearData : function() {
		$(OPER01010_GRID_ID).jqGrid('clearGridData', true);
		$(OPER01010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
		$(OPER01010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
		$(OPER01010_GRID_EMPTY).show();
	}, 
	unload : function() {
		$.jgrid.gridUnload(OPER01010_GRID_ID); 
	}
};

var itp_fn_OPER01010_search = function() {
	itp_fn_OPER01010_switch_screen('LIST');	
	itp_fn_OPER01010_grid.unload();
	itp_fn_OPER01010_grid.callBack();
};

let itp_OPER01010_param = {};
let itp_OPER01010_search = false;
var itp_fn_OPER01010_empty = {
	push: function() {
		let param = $('#ITP_FORM_OPER01010_SEARCH').serializeObject();
		itp_OPER01010_param = param;
	},
	back: function() {
		$('#ITP_FORM_OPER01010_DEVI_TP_CD').val(itp_OPER01010_param.deviTpCd);
		$('#ITP_FORM_OPER01010_ORDER_YN').val(itp_OPER01010_param.orderYn);
		$('#ITP_FORM_OPER01010_ADT_AUTH_CD').val(itp_OPER01010_param.adtAuthCd);
		$('#ITP_FORM_OPER01010_EMAIL_RCV_YN').val(itp_OPER01010_param.emailRcvYn);
		$('#ITP_FORM_OPER01010_MEMB_EXIT_DT').val(itp_OPER01010_param.membExitDt);
		$('#ITP_FORM_OPER01010_FROM_DT').val(itp_OPER01010_param.fromDt);
		$('#ITP_FORM_OPER01010_TO_DT').val(itp_OPER01010_param.toDt);
		$('#ITP_FORM_OPER01010_KEYWORD').val(itp_OPER01010_param.keyword);
	}
};

var itp_fn_OPER01010_view = function(param) {
	fn_ajax_call(USER_INFO_USER, param, itp_fn_OPER01010_view_callback, 'GET');
};

var itp_fn_OPER01010_view_callback = function(result) {
	// console.log(result);
	itp_fn_OPER01010_switch_screen('VIEW');
	$('#ITP_FORM_OPER01010_VIEW #ITP_FORM_OPER01010_VIEW_USER_ID').val(result.userId);
	$('#ITP_FORM_OPER01010_VIEW .fnUserNm').text(result.userNm);
	$('#ITP_FORM_OPER01010_VIEW .fnUserStatDt').text(result.userStatDt);
	$('#ITP_FORM_OPER01010_VIEW .fnUserStatNm').text(result.userStatNm);
	$('#ITP_FORM_OPER01010_VIEW .fnUserId').text(result.userId);
	$('#ITP_FORM_OPER01010_VIEW .fnEmail').text(result.email);
	$('#ITP_FORM_OPER01010_VIEW .fnTelNo').text(result.telNo);
	$('#ITP_FORM_OPER01010_VIEW .fnAddDt').text(result.addDt);
	$('#ITP_FORM_OPER01010_VIEW .fnLastLoginDt').text(result.lastLoginDt);
	
	// 권한정보 리스트 조회
	itp_fn_OPER01010_view_grid.unload();
	itp_fn_OPER01010_view_grid.callBack();
};

var itp_fn_OPER01010_view_grid = {
	init: function() {
	},
	callBack: function() {
		let param = $('#ITP_FORM_OPER01010_VIEW').serializeObject();
		param.gridSize = $.jgrid.defaults.rowNum; 
		param.pagingYn = false; // 페이징안함
		
		$(OPER01010_VIEW_GRID_ID).jqGrid({
			colModel: [
				{
					index: 'VIEW_CD', name: 'viewCd',
					label: ITP_MSG_LOCALE.label.viewCd,
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: true
				},
				{
					index: 'AUTH_NO', name: 'authNo',
					label: ITP_MSG_LOCALE.label.permitCd,
					width: '20', fixed: false, align: 'center',
					sortable: false, editable: false, edittype: 'text',
					editrules: {required: true}
				},
				{
					index: 'AUTH_NM', name: 'authNm',
					label: ITP_MSG_LOCALE.label.permitName,
					width: '30', fixed: false, align: 'center',
					sortable: true, editable: false, edittype: 'text',
					editrules: {required: true}
				},
				{
					index: 'USE_YN_NM', name: 'useYnNm',
					label: ITP_MSG_LOCALE.label.status,
					width: '10', fixed: false, align: 'center',
					sortable: false, editable: false, edittype: 'text'
				},
				{
					index: 'ADD_DT', name: 'addDt',
					label: ITP_MSG_LOCALE.label.regDt,
					width: '10', fixed: false, align: 'center',
					sortable: false, editable: false, edittype: 'text'
				}
			],
			loadBeforeSend: function(jqXHR) {
			    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
			},
			postData: JSON.stringify(param),
			url: DOMAIN + USER_USERAUTH_GRID_LIST,
			pager: OPER01010_VIEW_GRID_PAGER,
			multiselect: false,
			loadComplete: function(data) {				
				itp_fn_grid_load_complete(data, OPER01010_VIEW_GRID_ID, true, undefined, 'OPER01010_VIEW');
		    },
		    loadError: function(jqXHR, textStatus, errorThrown) {
		    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
		    },
		    onPaging: function(action) {
		    	var pagingFn = {
	    			callBack: function(args) {
	    				$(args).trigger('reloadGrid');
	    			}
	    		};
		    	if (itp_fn_check_grid_is_writing(OPER01010_VIEW_GRID_ID)) {
		    		itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, pagingFn, OPER01010_VIEW_GRID_ID);
		    		return 'stop';
		    	} else {
		    		itp_fn_grid_paging(OPER01010_VIEW_GRID_ID, action, param);
		    	}
		    },
		    onSortCol: function(index, columnIndex, sortOrder) {
		    	var sortingFn = {
	    			callBack: function(args) {
	    				$(args).trigger('reloadGrid');
	    			}
	    		};
		    	if (itp_fn_check_grid_is_writing(OPER01010_VIEW_GRID_ID)) {
		    		itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, sortingFn, OPER01010_VIEW_GRID_ID);
		    		return 'stop';
		    	} else {
		    		itp_fn_grid_sorting(OPER01010_VIEW_GRID_ID, index, sortOrder);
		    	}
		    }
		}).navGrid(OPER01010_VIEW_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
	},
	clearData : function() {
		$(OPER01010_VIEW_GRID_ID).jqGrid('clearGridData', true);
		$(OPER01010_VIEW_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
		$(OPER01010_VIEW_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
		$(OPER01010_VIEW_GRID_EMPTY).show();
	}, 
	unload : function() {
		$.jgrid.gridUnload(OPER01010_VIEW_GRID_ID); 
	}
};

var itp_fn_OPER01010_detail = function(param) {
	fn_ajax_call(USER_INFO_USER, param, itp_fn_OPER01010_detail_callback, 'GET');
};

var itp_fn_OPER01010_detail_callback = function(result) {
	// console.log(result);
	itp_fn_OPER01010_switch_screen('MODIFY');
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_VIEW_CD').val('U');
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_USER_NM').val(result.userNm);
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_USER_STAT_CD').val(result.userStatCd);
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_USER_ID').val(result.userId);
	$('#ITP_FORM_OPER01010_DETAIL .fnUserStatDt').text(result.userStatDt);
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_USER_PW').val(result.userPw);
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_USER_PW_CONFIRM').val(result.userPw);
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_TEL_NO').val(result.telNo);
	$('#ITP_FORM_OPER01010_DETAIL #ITP_FORM_OPER01010_DETAIL_EMAIL').val(result.email);
	$('#ITP_FORM_OPER01010_DETAIL .fnAddDt').text(result.addDt);
	$('#ITP_FORM_OPER01010_DETAIL .fnLastLoginDt').text(result.lastLoginDt);
	
	// 권한정보 리스트 조회
	itp_fn_OPER01010_detail_grid.unload();
	itp_fn_OPER01010_detail_grid.callBack();
};

var itp_fn_OPER01010_detail_grid = {
	init: function() {
	},
	callBack: function() {
		let param = $('#ITP_FORM_OPER01010_DETAIL').serializeObject();
		param.gridSize = $.jgrid.defaults.rowNum; 
		param.pagingYn = false; // 페이지안함 
		
		$(OPER01010_DETAIL_GRID_ID).jqGrid({
			colModel: [
				{
					index: 'VIEW_CD', name: 'viewCd',
					label: ITP_MSG_LOCALE.label.viewCd,
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: true
				},
				{
					index: 'AUTH_NO', name: 'authNo',
					label: ITP_MSG_LOCALE.label.permitCd,
					width: '20', fixed: false, align: 'center',
					sortable: false, editable: false, edittype: 'text',
					editrules: {required: true}
				},
				{
					index: 'AUTH_NM', name: 'authNm',
					label: ITP_MSG_LOCALE.label.permitName,
					width: '30', fixed: false, align: 'center',
					sortable: true, editable: false, edittype: 'text',
					editrules: {required: true}
				},
				{
					index: 'USE_YN_NM', name: 'useYnNm',
					label: ITP_MSG_LOCALE.label.status,
					width: '10', fixed: false, align: 'center',
					sortable: false, editable: false, edittype: 'text'
				},
				{
					index: 'ADD_DT', name: 'addDt',
					label: ITP_MSG_LOCALE.label.regDt,
					width: '10', fixed: false, align: 'center',
					sortable: false, editable: false, edittype: 'text'
				}
			],
			loadBeforeSend: function(jqXHR) {
			    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
			},
			postData: JSON.stringify(param),
			url: DOMAIN + USER_USERAUTH_GRID_LIST,
			pager: OPER01010_DETAIL_GRID_PAGER,
			loadComplete: function(data) {				
				itp_fn_grid_load_complete(data, OPER01010_DETAIL_GRID_ID, true, undefined, 'OPER01010_DETAIL');
		    },
		    loadError: function(jqXHR, textStatus, errorThrown) {
		    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
		    },
		    onPaging: function(action) {
		    	var pagingFn = {
	    			callBack: function(args) {
	    				$(args).trigger('reloadGrid');
	    			}
	    		};
		    	if (itp_fn_check_grid_is_writing(OPER01010_DETAIL_GRID_ID)) {
		    		itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, pagingFn, OPER01010_DETAIL_GRID_ID);
		    		return 'stop';
		    	} else {
		    		itp_fn_grid_paging(OPER01010_DETAIL_GRID_ID, action, param);
		    	}
		    },
		    onSortCol: function(index, columnIndex, sortOrder) {
		    	var sortingFn = {
	    			callBack: function(args) {
	    				$(args).trigger('reloadGrid');
	    			}
	    		};
		    	if (itp_fn_check_grid_is_writing(OPER01010_DETAIL_GRID_ID)) {
		    		itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, sortingFn, OPER01010_DETAIL_GRID_ID);
		    		return 'stop';
		    	} else {
		    		itp_fn_grid_sorting(OPER01010_DETAIL_GRID_ID, index, sortOrder);
		    	}
		    }
		}).navGrid(OPER01010_DETAIL_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
	},
	clearData : function() {
		$(OPER01010_DETAIL_GRID_ID).jqGrid('clearGridData', true);
		$(OPER01010_DETAIL_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
		$(OPER01010_DETAIL_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
		$(OPER01010_DETAIL_GRID_EMPTY).show();
	}, 
	unload : function() {
		$.jgrid.gridUnload(OPER01010_DETAIL_GRID_ID); 
	}
};

var itp_fn_OPER01010_brand_search = {
	init: function () {
		if(AUTH_TYPE_CD === '10' || AUTH_TYPE_CD === '20') {
			this.action();
		} else {
			this.make();
		}
	},
	make: function() {
		$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP').hide();
		$('#ITP_FORM_OPER01010_DELETE_AFFL_SHOP').hide();
		if(AFFL_SHOP_LIST) {
			$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP_ID').val(AFFL_SHOP_LIST[0].afflShopId);
			$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP_NM').val(AFFL_SHOP_LIST[0].afflShopNm);
		}
		if(AFFL_BRAND_LIST) {
			fn_make_select_brand(AFFL_BRAND_LIST, 'ITP_FORM_OPER01010_SEARCH_BRAND_ID');
		}
	},
	action: function () {
		var _this = this;
		// 가맹점 조회 버튼 클릭
		$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP').on('click', function() {
			_this.afflShop('L');
		});
		// 가맹점 텍스트 삭제 버튼 클릭
		$('#ITP_FORM_OPER01010_DELETE_AFFL_SHOP').on('click', function() {
			$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP_NM').val('');
			$('select#ITP_FORM_OPER01010_SEARCH_BRAND_ID option').remove();
		});
		// 신규등록 가맹점 조회 버튼 클릭
		$('#ITP_FORM_OPER01010_DETAIL_SEARCH_AFFL_SHOP').on('click', function() {
			_this.afflShop('C');
		});
		// 신규등록 가맹점 텍스트 삭제 버튼 클릭
		$('#ITP_FORM_OPER01010_DETAIL_DELETE_AFFL_SHOP').on('click', function() {
			$('#ITP_FORM_OPER01010_DETAIL_SEARCH_AFFL_SHOP_NM').val('');
			$('select#ITP_FORM_OPER01010_DETAIL_SEARCH_BRAND_ID option').remove();
		});
	},
	afflShop: function (view) {
		// 팝업
		var popFn = (view === 'C') ? this.callback.create : this.callback.list;
		fn_call_popup('biz', 'BIZPOP_AFFL_SHOP', '#ITP_ASIDE', popFn, null, 'S');
	},
	callback: {
		list: function(rowDataPop) {
			console.log(rowDataPop);
			if(rowDataPop.AFFL_SHOP) {
				$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP_ID').val(rowDataPop.AFFL_SHOP.afflShopId);
				$('#ITP_FORM_OPER01010_SEARCH_AFFL_SHOP_NM').val(rowDataPop.AFFL_SHOP.afflShopNm);
			}
			if(rowDataPop.AFFL_BRAND) {
				fn_make_select_brand(rowDataPop.AFFL_BRAND, 'ITP_FORM_OPER01010_SEARCH_BRAND_ID');
			}
		},
		create: function(rowDataPop) {
			console.log(rowDataPop);
			if(rowDataPop.AFFL_SHOP) {
				$('#ITP_FORM_OPER01010_DETAIL_SEARCH_AFFL_SHOP_ID').val(rowDataPop.AFFL_SHOP.afflShopId);
				$('#ITP_FORM_OPER01010_DETAIL_SEARCH_AFFL_SHOP_NM').val(rowDataPop.AFFL_SHOP.afflShopNm);
			}
			if(rowDataPop.AFFL_BRAND) {
				fn_make_select_brand(rowDataPop.AFFL_BRAND, 'ITP_FORM_OPER01010_DETAIL_SEARCH_BRAND_ID', true, '선택');
			}
		}
	}
};