
const OPER03010_GRID_ID = '#ITP_OPER03010_jqGrid';
const OPER03010_GRID_LIST = '#ITP_OPER03010_jqGrid_list';
const OPER03010_GRID_PAGER = '#ITP_OPER03010_jqGridPager';
const OPER03010_GRID_EMPTY = '#ITP_OPER03010_jqGridEmpty';

const OPER03010_VIEW_GRID_ID = '#ITP_OPER03010_VIEW_jqGrid';
const OPER03010_VIEW_GRID_LIST = '#ITP_OPER03010_VIEW_jqGrid_list';
const OPER03010_VIEW_GRID_PAGER = '#ITP_OPER03010_VIEW_jqGridPager';
const OPER03010_VIEW_GRID_EMPTY = '#ITP_OPER03010_VIEW_jqGridEmpty';

const OPER03010_DETAIL_GRID_ID = '#ITP_OPER03010_DETAIL_jqGrid';
const OPER03010_DETAIL_GRID_LIST = '#ITP_OPER03010_DETAIL_jqGrid_list';
const OPER03010_DETAIL_GRID_PAGER = '#ITP_OPER03010_DETAIL_jqGridPager';
const OPER03010_DETAIL_GRID_EMPTY = '#ITP_OPER03010_DETAIL_jqGridEmpty';

let ITP_FORM_OPER03010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_OPER03010_DETAIL_IS_WRITING = false;

let AFFL_DETAIL_GRID_LIST = '/api/affl/detail-grid-list';
let USER_SALESUSER_GRID_LIST = '/api/frcomp/cmpy-saleusers-list';
let COMPANY_INFO_COMPANY = '/api/frcomp/info-frcomp';
let COMPANY_SAVE_COMPANY = '/api/frcomp/save-frcomp';
let COMPANY_CHECK_DUPLICATE = '/api/frcomp/check-duplicate';
let USER_INTI_USERPW = '/api/user/inti-userpw';

require(['config'], function() {
	require([
	], function($) {
		pageObj.init();
	});
});

var pageObj = {
	init: function () {
		this.ui.init();
	},
	itp_OPER03010_param: {},
	itp_OPER03010_search: false,
	ui: {
		init: function () {
			this.button();
			this.comCode();
			this.ready();
		},
		button: function () {
			// 버튼 권한설정
			fn_proc_btn_auth('OPER03010');
		},
		comCode: function () {
			// 공통코드 표시
			fn_make_select(CODE_LIST, 'ST_CD', 'ITP_FORM_OPER03010_SEARCH_CMPY_STAT_CD', true, '상태(전체)');
			fn_make_select(CODE_LIST, 'ST_CD', 'ITP_FORM_OPER03010_DETAIL_CMPY_STAT_CD', true, '선택');
			fn_make_select(CODE_LIST, 'CMPY_TYPE_CD', 'ITP_FORM_OPER03010_DETAIL_CMPY_TYPE_CD', true, '선택');
			fn_make_select(CODE_LIST, 'FRCOMP_AUTH_CD', 'ITP_FORM_OPER03010_DETAIL_FRCOMP_AUTH_CD', true, '선택');
		},
		ready: function () {
			listObj.grid.init();
		}
	}
};

/*목록*/
var listObj = {
	grid: {
		init: function() {
			// 데이터 없을때
			this.itp_fn_OPER03010_empty.push();
			itp_fn_jqgrid_resize(OPER02010_GRID_ID, OPER02010_GRID_LIST, 'lg');
			itp_fn_OPER02010_grid.init();
			itp_fn_fire_window_resize();
			this.reload();
		},
		colModel: [
			{
				index: 'CMPY_CD', name: 'afflShopId',
				label: '가맹점코드',
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'CMPY_NM', name: 'afflShopNm',
				label: '가맹점명',
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'CORP_TYPE_NM', name: 'corpTypeNm',
				label: '기업형태',
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ST_NM', name: 'stNm',
				label: '기업상태',
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'OWNER_NM', name: 'ownerNm',
				label: '대표자명',
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'OWNER_TEL', name: 'ownerTel',
				label: '대표연락처',
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'JOIN_DT', name: 'joinDt',
				label: '가입일자',
				width: '8', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
		],
		load: function() {
			var _this = this;
			let param = $('#ITP_FORM_OPER03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			$(OPER03010_GRID_ID).jqGrid({
				colModel: this.colModel,
				loadBeforeSend: function(jqXHR) {
					jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
				},
				postData: JSON.stringify(param),
				url: DOMAIN + AFFL_DETAIL_GRID_LIST,
				pager: OPER03010_GRID_PAGER,
				multiselect: false,
				rownumbers: true,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					var cm = $(this).jqGrid('getGridParam', 'colModel');
					var colNm = cm[cellIdx].name;
					if (colNm == 'corpNm') {
						const cmpyCdVal = $(this).jqGrid('getCell', rowId, 'cmpyCd');
						const key = {cmpyCd: cmpyCdVal, viewCd: 'R'};
						var param = $.param(key);
						_this.itp_fn_OPER03010_view(param);
					}
				},
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, OPER03010_GRID_ID, true, 'number', 'OPER03010', pageObj.itp_OPER03010_search, _this.itp_fn_OPER03010_empty, true, data.gridRecords, true);
					var ids = $(OPER03010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(OPER03010_GRID_ID).jqGrid('setCell', rowId, 'cmpyNm', '', ITP_GRID_COL_STYLE.link);
					});
				},
				loadError: function(jqXHR, textStatus, errorThrown) {
					itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
				},
				onPaging: function(action) {
					itp_fn_grid_paging(OPER03010_GRID_ID, action, param);
				}
			}).navGrid(OPER03010_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
		},
		itp_fn_OPER03010_view: {
			call: function (param) {
				fn_ajax_call(COMPANY_INFO_COMPANY, param, this.callback, 'GET');
			},
			callback:  function(result) {
				// console.log(result);
				itp_fn_OPER03010_switch_screen('VIEW');
				$('#ITP_FORM_OPER03010_VIEW #ITP_FORM_OPER03010_VIEW_CMPY_CD').val(result.cmpyCd);

				$('#ITP_FORM_OPER03010_VIEW .fnCmpyNm').text(result.cmpyNm);
				$('#ITP_FORM_OPER03010_VIEW .fnCmpyStatCd').text(result.cmpyStatNm);
				$('#ITP_FORM_OPER03010_VIEW .fnCmpyCd').text(result.cmpyCd);
				$('#ITP_FORM_OPER03010_VIEW .fnCmpyTypeCd').text(result.cmpyTypeNm);
				$('#ITP_FORM_OPER03010_VIEW .fnCmpyRegNum').text(result.cmpyRegNum);
				$('#ITP_FORM_OPER03010_VIEW .fnFrcompAuthCd').text(result.frcompAuthNm);
				$('#ITP_FORM_OPER03010_VIEW .fnCoptNum').text(result.coptNum);
				$('#ITP_FORM_OPER03010_VIEW .fnBizCate').text(result.bizCate);
				$('#ITP_FORM_OPER03010_VIEW .fnBizType').text(result.bizType);
				$('#ITP_FORM_OPER03010_VIEW .fnBossNm').text(result.bossNm);
				$('#ITP_FORM_OPER03010_VIEW .fnMainTel').text(result.mainTel);
				$('#ITP_FORM_OPER03010_VIEW .fnMainFax').text(result.mainFax);
				$('#ITP_FORM_OPER03010_VIEW .fnMainEmail').text(result.mainEmail);
				$('#ITP_FORM_OPER03010_VIEW .fnCmpyAddress').text('('+ result.cmpyZipno + ') ' + result.cmpyAdres + ' ' + result.cmpyAdresDtl);

				$('#ITP_FORM_OPER03010_VIEW .fnAddDt').text(result.addDt);
				$('#ITP_FORM_OPER03010_VIEW .fnChgDt').text(result.chgDt);

				itp_fn_OPER03010_view_map(result.cmpyAdres);

				// 영업담당자정보  리스트 조회
				itp_fn_OPER03010_view_grid.unload();
				itp_fn_OPER03010_view_grid.callBack();
			}
		},
		itp_fn_OPER03010_empty: {
			push: function() {
				let param = $('#ITP_FORM_OPER03010_SEARCH').serializeObject();
				pageObj.itp_OPER03010_param = param;
			},
			back: function() {
				$('#ITP_FORM_OPER03010_DEVI_TP_CD').val(pageObj.itp_OPER03010_param.deviTpCd);
				$('#ITP_FORM_OPER03010_ORDER_YN').val(pageObj.itp_OPER03010_param.orderYn);
				$('#ITP_FORM_OPER03010_ADT_AUTH_CD').val(pageObj.itp_OPER03010_param.adtAuthCd);
				$('#ITP_FORM_OPER03010_EMAIL_RCV_YN').val(pageObj.itp_OPER03010_param.emailRcvYn);
				$('#ITP_FORM_OPER03010_SMS_RCV_YN').val(pageObj.itp_OPER03010_param.smsRcvYn);
				$('#ITP_FORM_OPER03010_MEMB_EXIT_DT').val(pageObj.itp_OPER03010_param.membExitDt);
				$('#ITP_FORM_OPER03010_FROM_DT').val(pageObj.itp_OPER03010_param.fromDt);
				$('#ITP_FORM_OPER03010_TO_DT').val(pageObj.itp_OPER03010_param.toDt);
				$('#ITP_FORM_OPER03010_KEYWORD').val(pageObj.itp_OPER03010_param.keyword);
			}
		},
		reload : function() {
			var _this = this;
			$(OPER03010_GRID_EMPTY).on('click', function() {
				_this.itp_fn_OPER03010_empty.back();
				pageObj.itp_OPER03010_param.gridSize = $.jgrid.defaults.rowNum;
				$(OPER03010_GRID_ID).setGridParam({'postData': JSON.stringify(pageObj.itp_OPER03010_param)}).trigger('reloadGrid');
			});
		},
		clearData : function() {
			$(OPER03010_GRID_ID).jqGrid('clearGridData', true);
			$(OPER03010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(OPER03010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(OPER03010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(OPER03010_GRID_ID);
		}
	}
};

var modifyObj = {

};

var createObj = {

};
